<!DOCTYPE html>
<html lang="en">

<head>
    <title> 06 API sample cho Pizza 365 Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<!-- file html dùng để thử tác động của javascript vào các thành phần trang web-->
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    //Ham fetch API
    function fetchAPI(url, options) {
        fetch(url, options)
            .then(
                (response) => {
                    return response.json();
                }
            )
            .then(
                (data) => {
                    console.log(data);
                }
            )
            .catch(
                (error) => {
                    console.error(error);
                }
            )
    }
    //gọi mẫu lấy danh sách order
    function onBtnGetAllOrderClick() {
        fetchAPI(vBASE_URL, { method: "GET" })
    }

    //gọi tạo một order mới
    function onCreateOrderClick() {
        fetchAPI(vBASE_URL, {
            method: 'POST',
            headers: {
                'Content-type': 'application/json; charset=UTF-8',
            },
            body: JSON.stringify({
                kichCo: "M",
                duongKinh: "25",
                suon: "4",
                salad: "300",
                loaiPizza: "HAWAII",
                idVourcher: "16512",
                idLoaiNuocUong: "PEPSI",
                soLuongNuoc: "3",
                hoTen: "Phạm Thanh Bình",
                thanhTien: "200000",
                email: "binhpt001@devcamp.edu.vn",
                soDienThoai: "0865241654",
                diaChi: "Hà Nội",
                loiNhan: "Pizza đế dày"
            })
        })
    }

    //gọi mẫu get order by ID
    function onGetOrderByIdClick() {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        var vOrderId = "K7VtSNBL02";

        fetchAPI(vBASE_URL + "/" + vOrderId, { method: "GET" })
    }

    //confirm hoặc cancel 01 order (update)
    function onUpdateOrderClick() {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        var vDatabaseIdOfOrder = "91";   //chú ý đây là ID tự sinh bởi Database, không phải là vOrderId, ( ví dụ: "qAsV7A3SRo")
        var vObjectRequest = {
            trangThai: "confirmed" //3: trang thai open, confirmed, cancel tùy tình huống
        }
        fetchAPI(vBASE_URL + "/" + vDatabaseIdOfOrder, {
            method: 'PUT',
            headers: {
                'Content-type': 'application/json; charset=UTF-8',
            },
            body: JSON.stringify(
                vObjectRequest
            )
        })
    }

    //check mã giảm giá

    function onCheckVoucherIdClick() {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/";
        const vVoucherId = "24864";

        fetch(vBASE_URL + vVoucherId)
            .then(response => {
                if (response.ok) {
                    return response.json();
                } else {
                    throw new Error("Request failed with status: " + response.status);
                }
            })
            .then(data => {
                console.log(data);
            })
            .catch(error => {
                console.error("Không tìm thấy voucher " + error);
            });
    }

    //mã nguồn để load data drink list (danh sách loại nước uống) về
    function onGetDrinkListClick() {
        const vBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/drinks";

        fetch(vBASE_URL)
            .then(response => {
                return response.json();
            })
            .then(data => {
                console.log(data);
            })
            .catch(error => {
                console.error(error);
            })
    }
</script>

<body class="jumbotron container">
    <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code. </p>
    <div class="row form-group">
        <button class="btn btn-info m-1" onclick="onBtnGetAllOrderClick()">Call api get all orders!</button>
        <button class="btn btn-success m-1" onclick="onCreateOrderClick()">Call api create order!</button>
        <button class="btn btn-warning m-1" onclick="onGetOrderByIdClick()">Call api get order by id!</button>
        <button class="btn btn-primary m-1" onclick="onUpdateOrderClick()">Call api update order!</button>
        <button class="btn btn-info m-1" onclick="onCheckVoucherIdClick()">Call api check voucher by id!</button>
        <button class="btn btn-danger m-1" onclick="onGetDrinkListClick()">Call api Get drink list!</button>
    </div>
    <div class="row form-group">
        <p id="testP" class="h4"> Demo 06 API for Pizza 365 Project: </p>
    </div>
    <div class="row form-group">
        <ul>
            <li>get all Orders: lấy tất cả orders </li>
            <li>create Order: tạo 1 order</li>
            <li>get Order by id: lấy 1 order bằng id </li>
            <li>update Order: update 01 order</li>
            <li>check voucher by id: check thông tin mã giảm giá, quan trọng là có hay không, và % giảm giá </li>
            <li>get drink list: lấy danh sách đồ uống</li>
        </ul>
    </div>
    <div class="row form-group">
        <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
    </div>
</body>

</html>